<template>

    <div class="container align-middle p-0 d-flex flex-column text-center">
        <header>
            <img src="../../assets/icon-left-font-monochrome-white.png" alt="Logo Groupomania" class="d-block mx-auto mt-5">
            <h1 class="text-light">Connexion</h1>
        </header>
        <div class="container align-middle p-0 d-flex flex-column text-center">
            <div class="form-group">
                <label class="mb-0 mt-2 text-light">Adresse Mail</label>
                <input class="form-control" v-model="form.email" type="email" id="mail" aria-label="Adresse mail">
                <p class="mt-0 mb-2 text-warning text-center">{{warning.email}}</p>
            </div>
            <div class="form-group mb-3">
                <label class="mb-0 mt-2 text-light">Mot de passe</label>
                <div class="input-group">
                    <input v-model="form.password" :type="passwordType.text" class="form-control password" aria-label="Mot de passe">
                    <div class="input-group-append">
                        <button class="btn btn-password" type="button" @click="() => showPassword = !showPassword" aria-label="Afficher le mot de passe">
                            <i v-bind:class="passwordType.icon"></i></button>
                    </div>
                </div>
                <p class="mt-0 mb-0 text-warning text-center">{{warning.password}}</p>
            </div>
            <div class="mt-3 d-flex justify-content-around">
                <button v-on:click="connexion()" class="btn btn-connexion text-light ml-2">Connexion</button>
            </div>
            <p class="text-light mt-5 mb-0 little-font">Pas de compte?</p>
            <router-link to="/inscription">
                <button class="btn btn-inscription text-light little-font">Inscrivez-vous</button>
            </router-link>

        </div>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                name: 'Connexion',
                form: {
                    email: '',
                    password: ''
                },
                warning: {
                    email: '',
                    password: ''
                },
                token: '',
                userId:'',
                isAdmin:false,
                showPassword: false
            }
        },
        computed: {
            passwordType() {
                const passType = {
                    text: "password",
                    icon: "fas fa-eye"
                }
                if (this.showPassword) {
                    passType.text = "text"
                    passType.icon = "fas fa-eye-slash"
                }
                return passType
            }
        },
        methods: {
            connexion: function () {
                const url = 'http://localhost:3000/api/users/login'
                const getMyToken = () => localStorage.getItem("token") !== null ? JSON.parse(localStorage
                    .getItem("token")) : []
                
                const axios = require('axios');
                if (this.form.email == '' && this.form.password == '') {
                    this.warning.email = 'Adresse e-mail obligatoire!'
                    this.warning.password = 'Mot de passe obligatoire!'
                }else if (this.form.password == '') {
                    this.warning.email = ''
                    this.warning.password = 'Mot de passe obligatoire!'
                }else if(this.form.email == ''){
                    this.warning.password = ''
                    this.warning.email = 'Adresse e-mail obligatoire!'
                }else{
                    this.warning.password = ''
                    this.warning.email = ''
                    axios.post(url, this.form)
                    .then(function (res) {
                            getMyToken()
                            this.token = JSON.stringify(res.data.token)
                            localStorage.setItem("token", this.token)
                            window.location.href='/'
                        }
                        .bind(this)
                    )
                    .catch((err) => {
                        if(err.message.indexOf(401)!== -1){
                            this.warning.password = 'Mot de passe erroné!'
                        }else if(err.message.indexOf(404)!== -1){
                            this.warning.password = "Utilisateur non enregistré! Inscrivez-vous!"
                        }
                    })
                }
            }
        }
    }
</script>

<style module src="./Connexion.css"></style>